--
-- Strautmann Giga Trailer 
-- Spezialization fr den Strautmann Giga Trailer 1850 DO
-- 
--
-- Author  Friedrich L.  -  Skullman
-- Date 1. August 2010
-- Web www.modding-society.de
--
-- Copyright (c) Friedrich L. - All Rights Reserved.
--

StrautmannGigaTrailer  = {};

function StrautmannGigaTrailer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations) and SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function StrautmannGigaTrailer:load(xmlFile)

    self.laderaumActive = false;
	self.brakeActive = false;
	self.laderaum = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lights#laderaum"));
	self.brake  = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lights#brake"));
    self.brakeVar = -0.005;
	
	self.Dosierwalze1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Dosierwalze#one"));
	self.Dosierwalze2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Dosierwalze#two"));
	self.speed = -50; 
	
end;

function StrautmannGigaTrailer:delete()
end;

function StrautmannGigaTrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function StrautmannGigaTrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function StrautmannGigaTrailer:update(dt)

	if InputBinding.hasEvent(InputBinding.Laderaumlicht) then
       	self.laderaumActive = not self.laderaumActive;
	end;
 		
	if self.attacherVehicle ~= nil then
	 self.canActiveBrake = true;
    end;
	
    local axis = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
    if self.attacherVehicle then
    if self.canActiveBrake and (self.attacherVehicle.movingDirection*self.attacherVehicle.lastSpeed*(-axis)) < -0.002 then 
      	self.brakeActive = true;
	 else
	  self.brakeActive = false;
	end;
	
	setVisibility(self.laderaum , self.laderaumActive);
	setVisibility(self.brake, self.brakeActive);
	
	if self.tipState == Trailer.TIPSTATE_OPENING then
		rotate(self.Dosierwalze1, self.speed, 0, 0); 
		rotate(self.Dosierwalze2, self.speed, 0, 0); 
    end;
	if self.tipState == Trailer.TIPSTATE_OPEN then
		rotate(self.Dosierwalze1, self.speed, 0, 0); 
		rotate(self.Dosierwalze2, self.speed, 0, 0); 
    end;
    end;	
end;

function StrautmannGigaTrailer:draw()
	g_currentMission:addExtraPrintText("Laderaumlicht an-/ausschalten : Taste: L");
end;

function StrautmannGigaTrailer:onDetach()
    	self.laderaumActive = false;
	self.brakeActive = false;
end;


function StrautmannGigaTrailer:onLeave()
    	self.laderaumActive = false;
	self.brakeActive = false;
end;
